﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;

namespace Row_Up_Down_MVC.Controllers
{
    public class HomeController : Controller
    {
        // GET: Home
        public ActionResult Index()
        {
            return View(this.GetHolidayLocations());
        }

        [HttpPost]
        public ActionResult Index(string action, int rowIndex)
        {
            List<HolidayLocation> holidayLocations = this.GetHolidayLocations();
            int locationId = holidayLocations[rowIndex].Id;
            int preference = holidayLocations[rowIndex].Preference;
            preference = action == "up" ? preference - 1 : preference + 1;
            this.UpdatePreference(locationId, preference);

            rowIndex = action == "up" ? rowIndex - 1 : rowIndex + 1;
            locationId = holidayLocations[rowIndex].Id;
            preference = holidayLocations[rowIndex].Preference;
            preference = action == "up" ? preference + 1 : preference - 1;
            this.UpdatePreference(locationId, preference);

            return RedirectToAction("Index", "Home");
        }

        private void UpdatePreference(int locationId, int preference)
        {
            AjaxSamplesEntities entities = new AjaxSamplesEntities();
            HolidayLocation holidayLocation = entities.HolidayLocations
                                              .Where(x => x.Id == locationId).FirstOrDefault();
            holidayLocation.Preference = preference;
            entities.SaveChanges();
        }

        private List<HolidayLocation> GetHolidayLocations()
        {
            AjaxSamplesEntities entities = new AjaxSamplesEntities();
            return (from location in entities.HolidayLocations.Take(10)
                    orderby location.Preference
                    select location).ToList();
        }
    }
}